#ifndef EXAMPLE_H_
#define EXAMPLE_H_

#include <stdint.h>

void init_macro(int N, const uint32_t op[][5]);
void run_macro(int M, uint32_t memory[8]);

#include <stdio.h>
#include <inttypes.h>

int main() {
  int N, Q, T, i, j;
  uint32_t op[80][5];
  uint32_t mem[8];
  scanf("%d", &N);
  for (i = 0; i < N; i++) {
    for (j = 0; j < 5; j++) scanf("%" SCNu32, op[i] + j);
  }
  init_macro(N, op);
  scanf("%d", &Q);
  while (Q--) {
    scanf("%d", &T);
    for (i = 0; i < 8; i++) scanf("%" SCNu32, mem + i);
    run_macro(T, mem);
    for (i = 0; i < 8; i++) printf("%" PRIu32 "%c", mem[i], " \n"[i == 7]);
  }
}

#endif /* EXAMPLE_H_ */
